// Code for measuring voltage and Current: Final Project
//Created on June 6, 2018
//Author Amith G Nair

float input_transformer_voltage=230.0;  //input voltage  pt meaured using voltmeter
float output_transformer_voltage=9.50;  // output voltage of pt meaured using voltmeter

int current_sensor = A0; // Analog input pin that sensor is attached to
float nVPP;   // Voltage measured across resistor
float nCurrThruResistorPP; // Peak Current Measured Through Resistor
float nCurrThruResistorRMS; // RMS current through Resistor
float nCurrentThruWire;     // Actual RMS current in Wire
float inst_filtered_voltage()
{

  int adc_voltage=analogRead(A1);
  long filtered_value=adc_voltage-511;
  float inst_voltage=(filtered_value*5.0*input_transformer_voltage*11.46)/(1024.0*output_transformer_voltage);
  return inst_voltage;
}
float rms_voltage()
{
  float sum_squared_voltage=0;
  for(int i=0;i&#;3000;i++)
  {
    float val=inst_filtered_voltage();
    float squared_voltage=val * val;
    sum_squared_voltage+=squared_voltage;
  }
  float mean_square_voltage = sum_squared_voltage / 3000.0;
  int rms_voltage = sqrt(mean_square_voltage);
  return rms_voltage;
}
void setup()
{
  Serial.begin(9600);

}
void loop()
{
  delay(1000);
  float voltage=rms_voltage();
  nVPP = getVPP();
  nCurrThruResistorPP = (nVPP/200.0)*1000;
  nCurrThruResistorRMS = nCurrThruResistorPP * 0.707;
  nCurrentThruWire = nCurrThruResistorRMS * 1000;
  float apparent_power =(voltage* nCurrentThruWire)/1000;
  String h = String(voltage);
  String i = String(nCurrentThruWire);
  String j = String(apparent_power);
  String payload = h;
  payload += ", "; payload += i; payload += ", ";
  payload += j;
  Serial.print(payload);
  Serial.println();
  delay(100);

 }

 float getVPP()
{
  float result;
  int readValue;             //value read from the sensor
  int maxValue = 0;          // store max value here
   uint32_t start_time = millis();
   while((millis()-start_time) < 1000) //sample for 1 Sec
   {
       readValue = analogRead(current_sensor);
       if (readValue > maxValue)
       {
           maxValue = readValue;
       }
   }
   result = (maxValue * 5.0)/1024.0;
   return result;
 }
